VirtualBox

source: vbox/trunk/configure@ 19286

Last change on this file since 19286 was 19129, checked in by vboxsync, 15 years ago

configure: fixed message

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
File size: 56.3 KB
Line 
1#!/bin/sh
2# The purpose of this script is to check for all external tools, headers, and
3# libraries VBox OSE depends on.
4
5#
6# Copyright (C) 2006-2009 Sun Microsystems, Inc.
7#
8# This file is part of VirtualBox Open Source Edition (OSE), as
9# available from http://www.virtualbox.org. This file is free software;
10# you can redistribute it and/or modify it under the terms of the GNU
11# General Public License as published by the Free Software Foundation,
12# in version 2 as it comes in the "COPYING" file of the VirtualBox OSE
13# distribution. VirtualBox OSE is distributed in the hope that it will
14# be useful, but WITHOUT ANY WARRANTY of any kind.
15#
16
17LC_ALL=C
18export LC_ALL
19
20# append some extra paths
21PATH="$PATH:/opt/gnome/bin"
22# Solaris (order of paths important for tr, echo, grep, sed to work)
23PATH="/usr/xpg4/bin:/usr/ucb:$PATH:/usr/local/bin:/usr/sfw/bin:/usr/ccs/bin"
24ORGPATH=$PATH
25
26# Wrapper for ancient /usr/bin/which on darwin that always returns 0
27which_wrapper()
28{
29 if [ -z "$have_ancient_which" ]; then
30 if which /bin/___cErTaINly_a_nOn_eXisTing_fIle___ 2> /dev/null > /dev/null; then
31 have_ancient_which="yes"
32 else
33 have_ancient_which="no"
34 fi
35 fi
36 if [ "$have_ancient_which" = "yes" ]; then
37 retval=`which $* 2>/dev/null`
38 echo "$retval"
39 test -n "$retval" -a -x "$retval"
40 unset retval
41 else
42 which $* 2> /dev/null
43 fi
44}
45
46
47#
48# Defaults
49#
50OSE=1
51ODIR="`pwd`/"
52ODIR_OVERRIDE=0
53OUT_PATH=""
54OUT_PATH_OVERRIDE=0
55SETUP_WINE=
56TARGET_MACHINE=""
57TARGET_CPU=""
58WITH_XPCOM=1
59WITH_PYTHON=1
60WITH_LIBIDL=1
61WITH_GSOAP=0
62WITH_QT4=1
63WITH_SDL=1
64WITH_SDL_TTF=1
65WITH_X11=1
66WITH_ALSA=1
67WITH_PULSE=1
68WITH_DBUS=1
69WITH_KMODS=1
70WITH_OPENGL=1
71WITH_HARDENING=1
72CC="gcc"
73CC32=""
74CC64=""
75CXX="g++"
76CXX32=""
77CXX64=""
78BCC="bcc"
79YASM="yasm"
80IASL="iasl"
81AS86="as86"
82XSLTPROC="xsltproc"
83GENISOIMAGE="genisoimage"
84MKISOFS="mkisofs"
85BUILD_LIBXML2=
86BUILD_LIBXSLT=
87LIBCRYPTO="-lcrypto"
88LIBPTHREAD="-lpthread"
89LIBCAP="-lcap"
90GSOAP=""
91GSOAP_IMPORT=""
92LIBX11="-L/usr/X11R6/lib -L/usr/X11R6/lib64 -L/usr/local/lib -lXext -lX11"
93INCX11="/usr/local/include"
94LIBXCURSOR="-lXcursor"
95LIBXMU="-lXmu"
96MESA="-lGL"
97INCZ=""
98LIBZ="-lz"
99INCPNG=""
100LIBPNG="-lpng"
101PKGCONFIG="`which_wrapper pkg-config`"
102PYTHONDIR="/usr /usr/local"
103QT4DIR="/usr/lib/qt4 /usr/share/qt4 /usr/lib64/qt4 /usr /usr/local"
104QT4DIR_PKGCONFIG=1
105QT4UIC3DIR="/usr/bin"
106KBUILDDIR="`cd \`dirname $0\`; pwd`/kBuild"
107DEVDIR="`cd \`dirname $0\`; pwd`/tools"
108if [ -d "/lib/modules/`uname -r`/build" ]; then
109 LINUX="/lib/modules/`uname -r`/build"
110else
111 LINUX="/usr/src/linux"
112fi
113KCHMVIEWER="kchmviewer"
114LOG="configure.log"
115CNF="AutoConfig.kmk"
116ENV="env.sh"
117BUILD_TYPE="release"
118# the restricting tool is ar (mri mode).
119INVALID_CHARS="[^A-Za-z0-9/\\$:._-]"
120
121if (cd `dirname $0`; pwd)|grep -q "$INVALID_CHARS"; then
122 echo "Error: VBox base path contains invalid characters!"
123 exit 1
124fi
125
126# darwin /bin/sh has a builtin echo that doesn't grok -n. gotta love it.
127if [ "`uname`" = "Darwin" ]; then
128 ECHO_N="/bin/echo -n"
129else
130 ECHO_N="echo -n"
131fi
132
133
134cleanup()
135{
136 rm -f $ODIR.tmp_src.cc $ODIR.tmp_src.c $ODIR.tmp_out $ODIR.test_execute.log
137}
138
139fail()
140{
141 if [ -z "$nofatal" -o "x$1" != "x" ]; then
142 cleanup
143 rm -f $ENV
144 exit 1
145 fi
146}
147
148log()
149{
150 echo "$1"
151 echo "$1" >> $LOG
152}
153
154log_success()
155{
156 if [ -n "$1" ]; then $ECHO_N "$1, "; fi
157 echo "OK."
158 echo "$1" >> $LOG
159 echo >> $LOG
160 echo >> $LOG
161}
162
163log_failure()
164{
165 echo
166 echo " ** $1!"
167 echo "** $1!" >> $LOG
168 echo >> $LOG
169}
170
171cnf_append()
172{
173 printf "%-30s := %s\n" "$1" "$2" >> $CNF
174}
175
176strip_l()
177{
178 echo "$1"|$KBUILD_SED 's|-l\([^ ]\+\)|\1|g; s|^-[^l][^ ]*||g; s| -[^l][^ ]*||g; s|^ ||; s| *$||g'
179}
180
181strip_L()
182{
183 echo "$1"|$KBUILD_SED 's|-L\([^ ]\+\)|\1|g; s|^-[^L][^ ]*||g; s| -[^L][^ ]*||g; s|^ ||; s| *$||g'
184}
185
186strip_I()
187{
188 echo "$1"|$KBUILD_SED 's|-I\([^ ]\+\)|\1|g; s|^-[^I][^ ]*||g; s| -[^I][^ ]*||g; s|^ ||; s| *$||g'
189}
190
191prefix_I()
192{
193 echo "$1"|$KBUILD_SED 's|^\/|-I/|g; s| \/| -I/|g'
194}
195
196check_avail()
197{
198 if [ -z "$1" ]; then
199 log_failure "$2 is empty"
200 fail $3
201 return 1
202 elif which_wrapper $1 > /dev/null; then
203 return 0
204 else
205 log_failure "$1 (variable $2) not found"
206 fail $3
207 return 1
208 fi
209}
210
211
212# Prepare a test
213test_header()
214{
215 echo "***** Checking $1 *****" >> $LOG
216 $ECHO_N "Checking for $1: "
217}
218
219
220# Compile a test
221# $1 compile flags/libs
222# $2 library name
223# $3 package name
224# $4 if this argument is 'nofatal', don't abort
225test_compile()
226{
227 echo "compiling the following source file:" >> $LOG
228 cat $ODIR.tmp_src.cc >> $LOG
229 echo "using the following command line:" >> $LOG
230 echo "$CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc \"$1\"" >> $LOG
231 $CXX -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc $1 >> $LOG 2>&1
232 if [ $? -ne 0 ]; then
233 if [ -z "$4" ]; then
234 echo
235 echo " $2 not found at $1 or $3 headers not found"
236 echo " Check the file $LOG for detailed error information."
237 fail
238 else
239 echo "not found."
240 echo >> $LOG
241 echo >> $LOG
242 fi
243 return 1
244 fi
245 return 0
246}
247
248
249# Execute a compiled test binary
250test_execute()
251{
252 echo "executing the binary" >> $LOG
253 $ODIR.tmp_out > $ODIR.test_execute.log
254 rc=$?
255 cat $ODIR.test_execute.log | tee -a $LOG
256 if [ $rc -ne 0 ]; then
257 fail $1
258 return 1
259 fi
260 echo >> $LOG
261 echo >> $LOG
262 return 0
263}
264
265
266# Execute a compiled test binary
267test_execute_path()
268{
269 echo "executing the binary (LD_LIBRARY_PATH=$1)" >> $LOG
270 LD_LIBRARY_PATH=$1 $ODIR.tmp_out > $ODIR.test_execute.log
271 rc=$?
272 cat $ODIR.test_execute.log | tee -a $LOG
273 if [ $rc -ne 0 ]; then
274 fail
275 return 1
276 fi
277 echo >> $LOG
278 echo >> $LOG
279 return 0
280}
281
282
283#
284# Check for OS, MACHINE, CPU
285#
286check_environment()
287{
288 test_header environment
289 OS=`uname -s | sed -e 's/GNU\/Linux/Linux/g' | tr [:upper:] [:lower:]`
290 case "$OS" in
291 linux)
292 ;;
293 darwin)
294 ;;
295 freebsd)
296 ;;
297 sunos)
298 OS='solaris'
299 ;;
300 *)
301 log_failure "Cannot determine OS"
302 exit 1
303 ;;
304 esac
305 BUILD_CPU=`uname -m`
306 [ "$OS" = "solaris" ] && BUILD_CPU=`isainfo | cut -f 1 -d ' '`
307 case "$BUILD_CPU" in
308 i[3456789]86|x86|i86pc)
309 BUILD_MACHINE='x86'
310 LIB='lib'
311 ;;
312 x86_64|amd64)
313 BUILD_MACHINE='amd64'
314 BUILD_CPU='k8'
315 if [ "$OS" != "solaris" ]; then
316 # on AMD64 systems, 64bit libs are usually located in /usr/lib64
317 # see http://www.pathname.com/fhs/pub/fhs-2.3.html#LIB64
318 LIB='lib64'
319 else
320 # Solaris doesn't seem to subscribe to fhs, libs are usually in
321 # a '64' subdirectory of the standard 'lib' dirs while some 64-bit
322 # alternative binaries can be found in 'amd64' subdirs of the 'bin'
323 # ones. So, in order to find the right stuff (esp. sdl-config) we'll
324 # have to make sure the */bin/amd64 dirs are searched before the */bin
325 # ones. (The sed has some sideeffects, but they shouldn't harm us...)
326 echo "64-bit Solaris detected, hacking the PATH" >> $LOG
327 echo "old PATH: $PATH" >> $LOG
328 PATH=`echo ":$PATH:" | sed -e 's,\(:[^:]*/bin\):,\1/amd64:\1:,g' \
329 -e 's/^:*//' -e 's/:*$//g' -e 's/::*/:/g' `
330 export PATH
331 echo "new PATH: $PATH" >> $LOG
332 LIB='lib/64'
333 fi
334 ;;
335 *)
336 log_failure "Cannot determine system"
337 exit 1
338 ;;
339 esac
340 [ -z "$TARGET_MACHINE" ] && TARGET_MACHINE=$BUILD_MACHINE
341 [ -z "$TARGET_CPU" ] && TARGET_CPU=$BUILD_CPU
342 DEVDIR_BIN="$DEVDIR/$OS.$BUILD_MACHINE/bin"
343 log_success "Determined build machine: $OS.$BUILD_MACHINE, target machine: $OS.$TARGET_MACHINE"
344
345 echo "export BUILD_PLATFORM=\"$OS\"" >> $ENV
346 echo "export BUILD_PLATFORM_ARCH=\"$BUILD_MACHINE\"" >> $ENV
347 echo "export BUILD_TARGET=\"$OS\"" >> $ENV
348 echo "export BUILD_TARGET_ARCH=\"$TARGET_MACHINE\"" >> $ENV
349 echo "export BUILD_TARGET_CPU=\"$TARGET_CPU\"" >> $ENV
350 echo "export BUILD_TYPE=\"$BUILD_TYPE\"" >> $ENV
351}
352
353#
354# Check for gcc with version >= 3.2.
355# We depend on a working gcc, if we fail terminate in every case.
356#
357check_gcc()
358{
359 test_header gcc
360 if check_avail "$CC" CC really; then
361 cc_ver=`$CC -dumpversion` 2>/dev/null
362 if [ $? -ne 0 ]; then
363 log_failure "cannot execute '$CC -dumpversion'"
364 fail really
365 fi
366 if check_avail "$CXX" CXX really; then
367 cxx_ver=`$CXX -dumpversion` 2>/dev/null
368 if [ $? -ne 0 ]; then
369 log_failure "cannot execute '$CXX -dumpversion'"
370 fail really
371 fi
372 cc_maj=`echo $cc_ver|cut -d. -f1`
373 cc_min=`echo $cc_ver|cut -d. -f2`
374 if [ "x$cc_ver" != "x$cxx_ver" ]; then
375 log_failure "gcc version $cc_ver does not match g++ version $cxx_ver"
376 fail really
377 elif [ $cc_maj -eq 4 -a $cc_min -eq 0 -a "OS" = "darwin" ]; then
378 log_success "found version $cc_ver"
379 elif [ $cc_maj -eq 4 -a $cc_min -eq 4 ]; then
380 log_success "found version $cc_ver"
381 log " WARNING: gcc version 4.4 was not extensively tested with the"
382 log " VirtualBox source code! Continue at your own risk!"
383 # gcc-4.0 is allowed for Darwin only
384 elif [ $cc_maj -lt 3 \
385 -o \( $cc_maj -eq 3 -a $cc_min -lt 2 \) \
386 -o \( $cc_maj -eq 4 -a $cc_min -lt 1 -a "$OS" != "darwin" \) \
387 -o \( $cc_maj -eq 4 -a $cc_min -gt 4 \) \
388 -o $cc_maj -gt 4 ]; then
389 log_failure "gcc version $cc_ver found, expected gcc 3.x with x>1 or gcc 4.x with 0<x<4"
390 fail really
391 else
392 log_success "found version $cc_ver"
393 fi
394 if [ "$BUILD_MACHINE" = "amd64" ]; then
395 [ -z "$CC32" ] && CC32="$CC -m32"
396 [ -z "$CXX32" ] && CXX32="$CXX -m32"
397 else
398 [ -z "$CC32" ] && CC32="$CC"
399 [ -z "$CXX32" ] && CXX32="$CXX"
400 fi
401 if [ "$BUILD_MACHINE" = "x86" -a "$TARGET_MACHINE" = "amd64" ]; then
402 [ -z "$CC64" ] && CC64="$CC -m64"
403 [ -z "$CXX64" ] && CXX64="$CXX -m64"
404 fi
405 if [ "$CC" != "gcc" ]; then
406 cnf_append "TOOL_GCC3_CC" "$CC"
407 cnf_append "TOOL_GCC3_AS" "$CC"
408 cnf_append "TOOL_GCC3_LD" "$CC"
409 cnf_append "TOOL_GXX3_CC" "$CC"
410 cnf_append "TOOL_GXX3_AS" "$CC"
411 fi
412 if [ "$CXX" != "g++" ]; then
413 cnf_append "TOOL_GCC3_CXX" "$CXX"
414 cnf_append "TOOL_GXX3_CXX" "$CXX"
415 cnf_append "TOOL_GXX3_LD" "$CXX"
416 fi
417 if [ "$CC32" != "gcc -m32" ]; then
418 cnf_append "TOOL_GCC32_CC" "$CC32"
419 cnf_append "TOOL_GCC32_AS" "$CC32"
420 cnf_append "TOOL_GCC32_LD" "$CC32"
421 cnf_append "TOOL_GXX32_CC" "$CC32"
422 cnf_append "TOOL_GXX32_AS" "$CC32"
423 fi
424 if [ "$CXX32" != "g++ -m32" ]; then
425 cnf_append "TOOL_GCC32_CXX" "$CXX32"
426 cnf_append "TOOL_GXX32_CXX" "$CXX32"
427 cnf_append "TOOL_GXX32_LD" "$CXX32"
428 fi
429 # this isn't not necessary, there is not such tool.
430 if [ -n "$CC64" ]; then
431 cnf_append "TOOL_GCC64_CC" "$CC64"
432 cnf_append "TOOL_GCC64_AS" "$CC64"
433 cnf_append "TOOL_GCC64_LD" "$CC64"
434 cnf_append "TOOL_GXX64_CC" "$CC64"
435 cnf_append "TOOL_GXX64_AS" "$CC64"
436 fi
437 if [ -n "$CXX64" ]; then
438 cnf_append "TOOL_GCC64_CXX" "$CXX64"
439 cnf_append "TOOL_GXX64_CXX" "$CXX64"
440 cnf_append "TOOL_GXX64_LD" "$CXX64"
441 fi
442 # Solaris sports a 32-bit gcc/g++.
443 if [ "$OS" = "solaris" -a "$BUILD_MACHINE" = "amd64" ]; then
444 [ "$CC" = "gcc" ] && CC="gcc -m64"
445 [ "$CXX" = "g++" ] && CXX="g++ -m64"
446 fi
447 fi
448 fi
449}
450
451
452#
453# Check for the bcc compiler, needed for compiling the BIOS
454#
455check_bcc()
456{
457 test_header bcc
458 if check_avail "$BCC" BCC; then
459 bcc_ver=`$BCC -v 2>&1|grep version|sed 's+^bcc: version \(.*\)+\1+'`
460 if [ $? -ne 0 ]; then
461 log_failure "not found"
462 fail
463 else
464 echo "compiling the following source file:" >> $LOG
465 cat > $ODIR.tmp_src.c << EOF
466int foo(a)
467 int a;
468{
469 return 0;
470}
471EOF
472 cat $ODIR.tmp_src.c >> $LOG
473 bcc_path=`which_wrapper $BCC`
474 bcc_dir="`dirname $bcc_path`/"
475 echo "using the following command line:" >> $LOG
476 echo "$BCC -B $bcc_dir -C-c -3 -S -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
477 $BCC -B $bcc_dir -C-c -3 -S -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
478 if [ $? -ne 0 ]; then
479 log_failure "not found"
480 fail
481 else
482 log_success "found version $bcc_ver"
483 cnf_append "VBOX_BCC" "$bcc_path -B $bcc_dir"
484 fi
485 unset bcc_path
486 unset bcc_dir
487 fi
488 fi
489}
490
491
492#
493# Check for the as86 assembler, needed for compiling the BIOS
494#
495check_as86()
496{
497 test_header as86
498 if check_avail "$AS86" AS86; then
499 as86_ver=`$AS86 -v 2>&1|grep version|sed 's+^as86 version: \(.*\)+\1+'`
500 if [ $? -ne 0 ]; then
501 log_failure "not found"
502 fail
503 else
504 log_success "found version $as86_ver"
505 cnf_append "VBOX_AS86" "`which_wrapper $AS86`"
506 fi
507 fi
508}
509
510
511#
512# Check for yasm, needed to compile assembler files
513#
514check_yasm()
515{
516 test_header yasm
517 if check_avail "$YASM" YASM; then
518 yasm_ver=`$YASM --version|grep "^yasm"|sed 's+^yasm \(.*\)+\1+'`
519 if [ $? -ne 0 ]; then
520 log_failure "not found"
521 fail
522 else
523 yasm_maj=`echo $yasm_ver|cut -d. -f1`
524 yasm_min=`echo $yasm_ver|cut -d. -f2`
525 yasm_rev=`echo $yasm_ver|cut -d. -f3`
526 yasm_ver_mul=`expr $yasm_maj \* 10000 + $yasm_min \* 100 + $yasm_rev`
527 if [ $yasm_ver_mul -lt 501 ]; then
528 log_failure "found version $yasm_ver, expected at least 0.5.1"
529 fail
530 else
531 log_success "found version $yasm_ver"
532 fi
533 fi
534 fi
535}
536
537
538#
539# Check for the iasl ACPI compiler, needed to compile vbox.dsl
540#
541check_iasl()
542{
543 test_header iasl
544 if check_avail "$IASL" IASL; then
545 iasl_ver=`$IASL|grep version|sed 's+^ASL.*version \([0-9]*\).*+\1+'`
546 if [ $? -ne 0 ]; then
547 log_failure "not found"
548 fail
549 else
550 log_success "found version $iasl_ver"
551 cnf_append "VBOX_IASLCMD" "`which_wrapper $IASL`"
552 fi
553 fi
554}
555
556
557#
558# Check for xsltproc, needed by Main
559#
560check_xsltproc()
561{
562 test_header xslt
563 if check_avail "$XSLTPROC" XSLTPROC; then
564 xsltproc_ver=`$XSLTPROC --version`
565 if [ $? -ne 0 ]; then
566 log_failure "not found"
567 fail
568 else
569 log_success "found"
570 cnf_append "VBOX_XSLTPROC" "`which_wrapper $XSLTPROC`"
571 fi
572 fi
573}
574
575
576#
577# Check for mkisofs, needed to build the CDROM image containing the additions
578#
579check_mkisofs()
580{
581 test_header mkisofs
582 if which_wrapper $GENISOIMAGE > /dev/null; then
583 mkisofs_ver=`$GENISOIMAGE --version`
584 if [ $? -ne 0 ]; then
585 log_failure "not found"
586 fail
587 else
588 log_success "found $mkisofs_ver"
589 cnf_append "VBOX_MKISOFS" "`which_wrapper $GENISOIMAGE`"
590 fi
591 elif check_avail "$MKISOFS" MKISOFS; then
592 mkisofs_ver=`$MKISOFS --version`
593 if [ $? -ne 0 ]; then
594 log_failure "not found"
595 fail
596 else
597 log_success "found $mkisofs_ver"
598 cnf_append "VBOX_MKISOFS" "`which_wrapper $MKISOFS`"
599 fi
600 fi
601}
602
603
604#
605# Check for libxml2, needed by VBoxSettings
606# 2.6.24 is known to NOT work, 2.6.26 is known to work (there is no 2.6.25 release)
607#
608check_libxml2()
609{
610 if [ -z "$BUILD_LIBXML2" ]; then
611 test_header libxml2
612 if which_wrapper pkg-config > /dev/null; then
613 libxml2_ver=`pkg-config libxml-2.0 --modversion 2>> $LOG`
614 if [ $? -ne 0 ]; then
615 log_failure "not found"
616 fail
617 else
618 FLGXML2=`pkg-config libxml-2.0 --cflags`
619 INCXML2=`strip_I "$FLGXML2"`
620 LIBXML2=`pkg-config libxml-2.0 --libs`
621 cat > $ODIR.tmp_src.cc << EOF
622#include <cstdio>
623#include <libxml/xmlversion.h>
624extern "C" int main(void)
625{
626 printf("found version %s", LIBXML_DOTTED_VERSION);
627#if LIBXML_VERSION >= 20626
628 printf(", OK.\n");
629 return 0;
630#else
631 printf(", expected version 2.6.26 or higher\n");
632 return 1;
633#endif
634}
635EOF
636 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
637 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
638 if test_execute; then
639 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
640 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
641 fi
642 fi
643 fi
644 elif which_wrapper xml2-config; then
645 libxml2_ver=`xml2-config --version`
646 if [ $? -ne 0 ]; then
647 log_failure "not found"
648 fail
649 else
650 log_success "found version $libxml2_ver"
651 FLGXML2=`xml2-config --cflags`
652 INCXML2=`strip_I "$FLGXML2"`
653 LIBXML2=`xml2-config --libs`
654 cat > $ODIR.tmp_src.cc << EOF
655#include <cstdio>
656#include <libxml/xmlversion.h>
657extern "C" int main(void)
658{
659 printf("found version %s", LIBXML_DOTTED_VERSION);
660#if LIBXML_VERSION >= 20626
661 printf(", OK.\n");
662 return 0;
663#else
664 printf(", expected version 2.6.26 or higher\n");
665 return 1;
666#endif
667}
668EOF
669 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
670 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
671 if test_execute; then
672 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
673 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
674 fi
675 fi
676 fi
677 else
678 log_failure "neither pkg-config nor xml2-config found"
679 fail
680 fi
681 fi
682}
683
684
685#
686# Check for libxslt, needed by VBoxSettings. For now we depend on 1.1.15,
687# as Solaris right now has no newer version and it definitely works.
688# 1.1.17 is available on Ubuntu Edgy which fulfils the minimal libxml2
689# requirement (2.6.26).
690#
691check_libxslt()
692{
693 if [ -z "$BUILD_LIBXSLT" ]; then
694 test_header libxslt
695 if which_wrapper pkg-config > /dev/null; then
696 libxslt_ver=`pkg-config libxslt --modversion 2>> $LOG`
697 if [ $? -ne 0 ]; then
698 log_failure "not found"
699 fail
700 else
701 FLGXSLT=`pkg-config libxslt --cflags`
702 INCXSLT=`strip_I "$FLGXSLT"`
703 LIBXSLT=`pkg-config libxslt --libs`
704 cat > $ODIR.tmp_src.cc << EOF
705#include <cstdio>
706#include <libxslt/xsltconfig.h>
707extern "C" int main(void)
708{
709 printf("found version %s", LIBXSLT_DOTTED_VERSION);
710#if LIBXSLT_VERSION >= 10117
711 printf(", OK.\n");
712 return 0;
713#else
714 printf(", expected version 1.1.17 or higher\n");
715 return 1;
716#endif
717}
718EOF
719 [ -n "$INCXSLT" ] && I_INCXSLT=`prefix_I "$INCXSLT"`
720 if test_compile "$LIBXSLT $LIBPTHREAD $I_INCXSLT" xslt xslt; then
721 if test_execute; then
722 cnf_append "SDK_VBOX_LIBXSLT_INCS" "$INCXSLT"
723 cnf_append "SDK_VBOX_LIBXSLT_LIBS" "`strip_l "$LIBXSLT"`"
724 fi
725 fi
726 fi
727 elif which_wrapper xslt-config; then
728 libxslt_ver=`xslt-config --version`
729 if [ $? -ne 0 ]; then
730 log_failure "not found"
731 fail
732 else
733 log_success "found version $libxslt_ver"
734 FLGXSLT=`xslt-config --cflags`
735 INCXSLT=`strip_I "$FLGXSLT"`
736 LIBXSLT=`xslt-config --libs`
737 cat > $ODIR.tmp_src.cc << EOF
738#include <cstdio>
739#include <libxslt/xsltconfig.h>
740extern "C" int main(void)
741{
742 printf("found version %s", LIBXSLT_DOTTED_VERSION);
743#if LIBXSLT_VERSION >= 10117
744 printf(", OK.\n");
745 return 0;
746#else
747 printf(", expected version 1.1.17 or higher\n");
748 return 1;
749#endif
750}
751EOF
752 [ -n "$INCXSLT" ] && I_INCXSLT=`prefix_I "$INCXSLT"`
753 if test_compile "$LIBXSLT $LIBPTHREAD $I_INCXSLT" xslt xslt; then
754 if test_execute; then
755 cnf_append "SDK_VBOX_LIBXSLT_INCS" "$INCXSLT"
756 cnf_append "SDK_VBOX_LIBXSLT_LIBS" "`strip_l "$LIBXSLT"`"
757 fi
758 fi
759 fi
760 else
761 log_failure "neither pkg-config nor xslt-config found"
762 fail
763 fi
764 fi
765}
766
767
768#
769# Check for libIDL, needed by xpcom
770#
771check_libidl()
772{
773 test_header libIDL
774
775 if which_wrapper libIDL-config-2 > /dev/null; then
776 libidl_ver=`libIDL-config-2 --version`
777 if [ $? -ne 0 ]; then
778 log_failure "not found"
779 fail
780 else
781 log_success "found version $libidl_ver"
782 cnf_append "VBOX_LIBIDL_CONFIG" \
783 "PKG_CONFIG_PATH=`libIDL-config-2 --prefix`/$LIB/pkgconfig `which_wrapper libIDL-config-2`"
784 fi
785 elif check_avail "libIDL-config" libIDL-config; then
786 libidl_ver=`libIDL-config --version`
787 if [ $? -ne 0 ]; then
788 log_failure "not found"
789 fail
790 else
791 log_success "found version $libidl_ver"
792 cnf_append "VBOX_LIBIDL_CONFIG" "`which_wrapper libIDL-config`"
793 fi
794 fi
795}
796
797
798#
799# Check for openssl, needed for RDP
800#
801check_ssl()
802{
803 test_header ssl
804 cat > $ODIR.tmp_src.cc << EOF
805#include <cstdio>
806#include <openssl/opensslv.h>
807extern "C" int main(void)
808{
809 printf("found version %s", OPENSSL_VERSION_TEXT);
810#if OPENSSL_VERSION_NUMBER >= 0x0090700
811 printf(", OK.\n");
812 return 0;
813#else
814 printf(", expected version 0.9.7 or higher\n");
815 return 1;
816#endif
817}
818EOF
819 if test_compile $LIBCRYPTO libcrypto openssl; then
820 if test_execute nofatal; then
821 cnf_append "SDK_VBOX_OPENSSL_INCS" ""
822 cnf_append "SDK_VBOX_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
823 fi
824 fi
825}
826
827
828#
829# Check for pthread, needed by VBoxSVC, frontends, ...
830#
831check_pthread()
832{
833 test_header pthread
834 cat > $ODIR.tmp_src.cc << EOF
835#include <cstdio>
836#include <pthread.h>
837extern "C" int main(void)
838{
839 pthread_mutex_t mutex;
840 if (pthread_mutex_init(&mutex, NULL)) {
841 printf("pthread_mutex_init() failed\n");
842 return 1;
843 }
844 if (pthread_mutex_lock(&mutex)) {
845 printf("pthread_mutex_lock() failed\n");
846 return 1;
847 }
848 if (pthread_mutex_unlock(&mutex)) {
849 printf("pthread_mutex_unlock() failed\n");
850 return 1;
851 }
852 printf("found, OK.\n");
853}
854EOF
855 if test_compile $LIBPTHREAD pthread pthread; then
856 if test_execute; then
857 cnf_append "LIB_PTHREAD" "`strip_l "$LIBPTHREAD"`"
858 fi
859 fi
860}
861
862
863#
864# Check for zlib, needed by VBoxSVC, Runtime, ...
865#
866check_z()
867{
868 test_header zlib
869 cat > $ODIR.tmp_src.cc << EOF
870#include <cstdio>
871#include <zlib.h>
872extern "C" int main(void)
873{
874 printf("found version %s", ZLIB_VERSION);
875#if ZLIB_VERNUM >= 0x1210
876 printf(", OK.\n");
877 return 0;
878#else
879 printf(", expected version 1.2.1 or higher\n");
880 return 1;
881#endif
882}
883EOF
884 [ -n "$INCZ" ] && I_INCZ=`prefix_I "$INCZ"`
885 if test_compile "$LIBZ $I_INCZ" zlib zlib; then
886 if test_execute; then
887 cnf_append "SDK_VBOX_ZLIB_LIBS" "`strip_l "$LIBZ"`"
888 cnf_append "SDK_VBOX_ZLIB_INCS" "$INCZ"
889 fi
890 fi
891}
892
893
894#
895# Check for libpng, needed by kchmviewer
896#
897check_png()
898{
899 test_header libpng
900 cat > $ODIR.tmp_src.cc << EOF
901#include <cstdio>
902#include <png.h>
903extern "C" int main(void)
904{
905 printf("found version %s", PNG_LIBPNG_VER_STRING);
906#if PNG_LIBPNG_VER >= 10205
907 printf(", OK.\n");
908 return 0;
909#else
910 printf(", expected version 1.2.5 or higher\n");
911 return 1;
912#endif
913}
914EOF
915 [ -n "$INCPNG" ] && I_INCPNG=`prefix_I "$INCPNG"`
916# if test_compile "$LIBPNG $I_INCPNG" libpng libpng nofatal; then
917 if test_compile "$LIBPNG $I_INCPNG" libpng libpng; then
918# if test_execute nofatal; then
919 if test_execute; then
920 cnf_append "SDK_VBOX_LIBPNG_LIBS" "`strip_l "$LIBPNG"`"
921 cnf_append "SDK_VBOX_LIBPNG_INCS" "$INCPNG"
922 fi
923 fi
924}
925
926
927#
928# Check for pam, needed by VRDPAuth
929# Version 79 was introduced in 9/2005, do we support older versions?
930# Debian/sarge uses 76
931# OpenSUSE comes with 0.99.xxx where they changed the versioning scheme.
932#
933check_pam()
934{
935 test_header pam
936 cat > $ODIR.tmp_src.cc << EOF
937#include <cstdio>
938#include <security/pam_appl.h>
939extern "C" int main(void)
940{
941 printf("found version %d", __LIBPAM_VERSION);
942 if (__LIBPAM_VERSION >= 76)
943 {
944 printf(", OK.\n");
945 return 0;
946 }
947 else
948 {
949 printf(", expected version 76 or higher\n");
950 return 1;
951 }
952}
953EOF
954 if test_compile "-lpam" pam pam nofatal; then
955 if test_execute nofatal; then
956 return 0;
957 fi
958 fi
959 test_header linux_pam
960 cat > $ODIR.tmp_src.cc << EOF
961#include <cstdio>
962#include <security/pam_appl.h>
963extern "C" int main(void)
964{
965 printf("found version %d.%d", __LINUX_PAM__, __LINUX_PAM_MINOR__);
966 if (__LINUX_PAM__ >= 1)
967 {
968 printf(", OK.\n");
969 return 0;
970 }
971 else
972 {
973 printf(", expected version 1.0 or higher\n");
974 return 1;
975 }
976}
977EOF
978 if test_compile "-lpam" pam pam; then
979 test_execute
980 fi
981}
982
983
984#
985# Check for the SDL library, needed by VBoxSDL and VirtualBox
986# We depend at least on version 1.2.7
987#
988check_sdl()
989{
990 test_header SDL
991 if [ "$OS" = "darwin" ]; then
992 if [ -f "/System/Library/Frameworks/SDL.framework/SDL" ]; then
993 PATH_SDK_LIBSDL="/System/Library/Frameworks/SDL.framework"
994 elif [ -f "/Library/Frameworks/SDL.framework/SDL" ]; then
995 PATH_SDK_LIBSDL="/Library/Frameworks/SDL.framework"
996 fi
997 if [ -n "$PATH_SDK_LIBSDL" ]; then
998 foundsdl=1
999 INCSDL="$PATH_SDK_LIBSDL/Headers"
1000 FLDSDL="-framework SDL"
1001 else
1002 log_failure "SDL framework not found"
1003 fail
1004 fi
1005 else
1006 if which_wrapper sdl-config > /dev/null; then
1007 FLGSDL=`sdl-config --cflags`
1008 INCSDL=`strip_I "$FLGSDL"`
1009 LIBSDL=`sdl-config --libs`
1010 LIBSDLMAIN="-lSDLmain"
1011 FLDSDL=
1012 foundsdl=1
1013 fi
1014 fi
1015 [ "$OS" = "linux" -o "$OS" = "darwin" -o "$OS" = "solaris" ] && LIBSDLMAIN=""
1016 if [ -n "$foundsdl" ]; then
1017 cat > $ODIR.tmp_src.cc << EOF
1018#include <cstdio>
1019#include <SDL.h>
1020#include <SDL_main.h>
1021#undef main
1022extern "C" int main(int argc, char** argv)
1023{
1024 printf("found version %d.%d.%d",
1025 SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
1026#if SDL_VERSION_ATLEAST(1,2,7)
1027 printf(", OK.\n");
1028 return 0;
1029#else
1030 printf(", expected version 1.2.7 or higher\n");
1031 return 1;
1032#endif
1033}
1034EOF
1035 [ -n "$INCSDL" ] && I_INCSDL=`prefix_I "$INCSDL"`
1036 if test_compile "$LIBSDL $LIBSDLMAIN $I_INCSDL $FLDSDL" SDL SDL; then
1037 if test_execute; then
1038 cnf_append "LIB_SDK_LIBSDL_SDL" "`strip_l "$LIBSDL"`"
1039 cnf_append "SDK_LIBSDL_LIBPATH" "`strip_L "$LIBSDL"`"
1040 cnf_append "LIB_SDK_LIBSDL_SDLMAIN" "`strip_l "$LIBSDLMAIN"`"
1041 [ -n "$INCSDL" ] && cnf_append "SDK_LIBSDL_INCS" "$INCSDL"
1042 [ -n "$FLDSDL" ] && cnf_append "SDK_LIBSDL_LDFLAGS" "$FLDSDL"
1043 fi
1044 fi
1045 else
1046 log_failure "not found"
1047 fail
1048 fi
1049}
1050
1051
1052#
1053# Check for the SDL_ttf library, needed by VBoxSDL (secure label)
1054#
1055check_sdl_ttf()
1056{
1057 test_header SDL_ttf
1058 cat > $ODIR.tmp_src.cc << EOF
1059#include <cstdio>
1060#include <SDL_ttf.h>
1061#ifndef SDL_TTF_MAJOR_VERSION
1062#define SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION
1063#define SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION
1064#define SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL
1065#endif
1066extern "C" int main(void)
1067{
1068 printf("found version %d.%d.%d",
1069 SDL_TTF_MAJOR_VERSION, SDL_TTF_MINOR_VERSION, SDL_TTF_PATCHLEVEL);
1070#if 10000*SDL_TTF_MAJOR_VERSION + 100*SDL_TTF_MINOR_VERSION + SDL_TTF_PATCHLEVEL >= 20006
1071 printf(", OK.\n");
1072 return 0;
1073#else
1074 printf(", expected version 2.0.6 or higher\n");
1075 return 1;
1076#endif
1077}
1078EOF
1079 if test_compile "-lSDL_ttf $I_INCSDL" SDL_ttf SDL_ttf nofatal; then
1080 if ! test_execute nofatal; then
1081 cnf_append "VBOX_WITH_SECURELABEL" ""
1082 fi
1083 else
1084 cnf_append "VBOX_WITH_SECURELABEL" ""
1085 fi
1086}
1087
1088
1089#
1090# Check for libasound, needed by the ALSA audio backend
1091#
1092check_alsa()
1093{
1094 test_header ALSA
1095 cat > $ODIR.tmp_src.cc << EOF
1096#include <cstdio>
1097#include <alsa/asoundlib.h>
1098extern "C" int main(void)
1099{
1100 printf("found version %d.%d.%d",
1101 SND_LIB_MAJOR, SND_LIB_MINOR, SND_LIB_SUBMINOR);
1102#if 10000*SND_LIB_MAJOR + 100*SND_LIB_MINOR + SND_LIB_SUBMINOR >= 10006
1103 printf(", OK.\n");
1104 return 0;
1105#else
1106 printf(", expected version 1.0.6 or higher\n");
1107 return 1;
1108#endif
1109}
1110EOF
1111 if test_compile "-lasound" asound asound; then
1112 test_execute
1113 fi
1114}
1115
1116
1117#
1118# Check for PulseAudio
1119#
1120check_pulse()
1121{
1122 test_header "PulseAudio"
1123 cat > $ODIR.tmp_src.cc << EOF
1124#include <cstdio>
1125#include <pulse/version.h>
1126extern "C" int main(void)
1127{
1128 printf("found version %s API version %d", pa_get_headers_version(), PA_API_VERSION);
1129#if PA_API_VERSION >= 9
1130 printf(", OK.\n");
1131 return 0;
1132#else
1133 printf(", expected version 0.9.0 (API version 9) or higher\n");
1134 return 1;
1135#endif
1136}
1137EOF
1138 if test_compile "-lpulse" pulse pulse; then
1139 test_execute
1140 fi
1141}
1142
1143
1144#
1145# Check for the X libraries (Xext, X11)
1146#
1147check_x()
1148{
1149 test_header "X libraries"
1150 cat > $ODIR.tmp_src.cc << EOF
1151#include <cstdio>
1152#include <X11/Xlib.h>
1153extern "C" int main(void)
1154{
1155 Display *dpy;
1156 int scrn_num;
1157 Screen *scrn;
1158 Window win;
1159
1160 dpy = XOpenDisplay(NULL);
1161 scrn_num = DefaultScreen(dpy);
1162 scrn = ScreenOfDisplay(dpy, scrn_num);
1163 win = XCreateWindow(dpy, RootWindowOfScreen(scrn), 0, 0, 100, 100,
1164 0, 16, InputOutput, CopyFromParent, 0, NULL);
1165 XDestroyWindow(dpy, win);
1166}
1167EOF
1168 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1169 if test_compile "$LIBX11 $I_INCX11" Xlibs Xlibs; then
1170 log_success "found"
1171 fi
1172}
1173
1174
1175#
1176# Check for the Xcursor library, needed by VBoxSDL and VBoxBFE
1177#
1178check_xcursor()
1179{
1180 test_header Xcursor
1181 cat > $ODIR.tmp_src.cc << EOF
1182#include <cstdio>
1183#include <X11/Xlib.h>
1184#include <X11/Xcursor/Xcursor.h>
1185extern "C" int main(void)
1186{
1187 XcursorImage *cursor = XcursorImageCreate (10, 10);
1188 XcursorImageDestroy(cursor);
1189 return 0;
1190}
1191EOF
1192 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1193 if test_compile "$LIBX11 $LIBXCURSOR $I_INCX11" Xcursor Xcursor; then
1194 log_success "found"
1195 cnf_append "VBOX_XCURSOR_LIBS" "`strip_l "$LIBXCURSOR"`"
1196 fi
1197}
1198
1199
1200#
1201# Check for the Xmu library, needed by OpenGL
1202#
1203check_xmu()
1204{
1205 test_header Xmu
1206 cat > $ODIR.tmp_src.cc << EOF
1207#include <cstdio>
1208#include <X11/Xatom.h>
1209#include <X11/Xlib.h>
1210#include <X11/Xutil.h>
1211#include <X11/Xmu/StdCmap.h>
1212extern "C" int main(void)
1213{
1214 Display *dpy;
1215 int scrn_num;
1216 Screen *scrn;
1217
1218 dpy = XOpenDisplay(NULL);
1219 if (dpy)
1220 {
1221 scrn_num = DefaultScreen(dpy);
1222 scrn = ScreenOfDisplay(dpy, scrn_num);
1223 Status status = XmuLookupStandardColormap(dpy, RootWindowOfScreen(scrn), 0,
1224 24, XA_RGB_DEFAULT_MAP, False, True);
1225 printf("Status = %x\n", status);
1226 }
1227 return 0;
1228}
1229EOF
1230 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1231 if test_compile "$LIBX11 $LIBXMU $I_INCX11" Xmu Xmu; then
1232 log_success "found"
1233 cnf_append "VBOX_XMU_LIBS" "`strip_l "$LIBXMU"`"
1234 fi
1235}
1236
1237
1238#
1239# Check for Mesa, needed by OpenGL
1240#
1241check_mesa()
1242{
1243 test_header "Mesa / GLU"
1244 cat > $ODIR.tmp_src.cc << EOF
1245#include <cstdio>
1246#include <X11/Xlib.h>
1247#include <GL/glx.h>
1248#include <GL/glu.h>
1249extern "C" int main(void)
1250{
1251 Display *dpy;
1252 int major, minor;
1253
1254 dpy = XOpenDisplay(NULL);
1255 if (dpy)
1256 {
1257 if (glXQueryVersion(dpy, &major, &minor))
1258 {
1259 printf("found version %u.%u, OK.\n", major, minor);
1260 return 0;
1261 }
1262 }
1263 printf("found (inactive), OK.\n");
1264 return 0;
1265}
1266EOF
1267 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1268 if test_compile "$LIBX11 $MESA $I_INCX11" Mesa Mesa; then
1269 test_execute
1270 fi
1271}
1272
1273
1274#
1275# Check for the Qt4 library, needed by the VirtualBox frontend
1276#
1277# Currently not fatal.
1278#
1279check_qt4()
1280{
1281 foundqt4=
1282 test_header Qt4
1283 if [ "$OS" = "darwin" ]; then
1284 if [ -f "/System/Library/Frameworks/QtCore.framework/QtCore" ]; then
1285 PATH_SDK_QT4="/System/Library/Framework/QtCore.framework"
1286 elif [ -f "/Library/Frameworks/QtCore.framework/QtCore" ]; then
1287 PATH_SDK_QT4="/Library/Frameworks/QtCore.framework"
1288 fi
1289 if [ -n "$PATH_SDK_QT4" ]; then
1290 foundqt4=1
1291 INCQT4="$PATH_SDK_QT4/Headers"
1292 LIBQT4=
1293 FLGQT4="-framework QtCore"
1294 else
1295 log_failure "Qt4 framework not found (can be disabled using --disable-qt4)"
1296 fail
1297 fi
1298 else
1299 if [ $QT4DIR_PKGCONFIG -eq 1 ]; then
1300 # default is to use pkg-config
1301 if which_wrapper pkg-config > /dev/null; then
1302 # this braindead path is necessary for mdv2008.1
1303 qt4_ver=`\
1304 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1305 pkg-config QtCore --modversion 2>> $LOG`
1306 if [ $? -ne 0 ]; then
1307 log_failure "not found"
1308 fail
1309 else
1310 FLGQT4=`\
1311 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1312 pkg-config QtCore --cflags`
1313 INCQT4=`strip_I "$FLGQT4"`
1314 LIBQT4=`\
1315 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1316 PKG_CONFIG_ALLOW_SYSTEM_LIBS=1 \
1317 pkg-config QtCore --libs`
1318 foundqt4=1
1319 fi
1320 else
1321 log_failure "pkg-config not found"
1322 fail
1323 fi
1324 else
1325 # do it the old way (e.g. user has specified QT4DIR)
1326 cat > $ODIR.tmp_src.cc << EOF
1327#include <cstdio>
1328#include <QtGlobal>
1329extern "C" int main(void)
1330{
1331 printf("found version %s", QT_VERSION_STR);
1332#if QT_VERSION >= 0x040300
1333 printf(", OK.\n");
1334 return 0;
1335#else
1336 printf(", expected version 4.3.0 or higher\n");
1337 return 1;
1338#endif
1339}
1340EOF
1341 for q in $QT4DIR; do
1342 INCQT4="$q/include $q/include/QtCore"
1343 FLGQT4="-DQT_SHARED"
1344 I_INCQT4=`prefix_I "$INCQT4"`
1345 LIBQT4="-L$q/lib -lQtCoreVBox"
1346 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1347 foundqt4=2
1348 break;
1349 fi
1350 LIBQT4="-L$q/lib -lQtCore"
1351 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1352 foundqt4=1
1353 break;
1354 fi
1355 done
1356 fi
1357 fi
1358 if [ -n "$foundqt4" ]; then
1359 cat > $ODIR.tmp_src.cc << EOF
1360#include <cstdio>
1361#include <QtGlobal>
1362extern "C" int main(void)
1363{
1364 printf("found version %s", QT_VERSION_STR);
1365#if QT_VERSION >= 0x040300
1366 printf(", OK.\n");
1367 return 0;
1368#else
1369 printf(", expected version 4.3.0 or higher\n");
1370 return 1;
1371#endif
1372}
1373EOF
1374 [ -n "$INCQT4" ] && I_INCQT4=`prefix_I "$INCQT4"`
1375 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1376 if test_execute_path "`strip_L "$LIBQT4"`"; then
1377 if [ "$OS" != "darwin" ]; then
1378 # strip .../QtCore as we add components ourself
1379 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\)/QtCore|\1|g; s| $||g'`
1380 # store only the first path, remove all other pathes
1381 # most likely pkg-config gave us -I/usr/include/qt4 -I/usr/include/qt4/QtCore
1382 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\) .*|\1|'`
1383 cnf_append "VBOX_PATH_QT4_LIB" "`strip_L "$LIBQT4"`"
1384 cnf_append "SDK_QT4_LIBPATH" "`strip_L "$LIBQT4"`"
1385 cnf_append "PATH_SDK_QT4_INC" "$INCQT4"
1386 # this is not quite right since the qt libpath does not have to be first...
1387 cnf_append "PATH_SDK_QT4_LIB" '$'"(firstword `strip_L "$LIBQT4"`)"
1388 if [ "$foundqt4" = "2" ]; then
1389 cnf_append "VBOX_WITH_QT4_SUN" "1"
1390 fi
1391 test_header "Qt4 devtools"
1392 for q in $QT4DIR; do
1393 if which_wrapper "$q/bin/moc" > /dev/null; then
1394 moc_ver=`$q/bin/moc -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1395 if [ $? -ne 0 ]; then
1396 log_failure "not found"
1397 fail
1398 else
1399 log_success "found version $moc_ver"
1400 cnf_append "VBOX_PATH_QT4" "$q"
1401 cnf_append "PATH_SDK_QT4" "$q"
1402 cnf_append "PATH_TOOL_QT4" "$q"
1403 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1404 return
1405 fi
1406 fi
1407 done
1408 fi
1409 fi
1410 else
1411 log_failure "not found"
1412 fail
1413 fi
1414 else
1415 log_failure "not found"
1416 fail
1417 fi
1418}
1419
1420
1421#
1422# Check whether static libstdc++ is installed. This library is required
1423# for the Linux guest additions.
1424#
1425check_staticlibstdcxx()
1426{
1427 test_header "static stc++ library"
1428 libstdcxx=`$CXX -print-file-name=libstdc++.a`
1429 cat > $ODIR.tmp_src.cc << EOF
1430#include <string>
1431
1432extern "C" int main(void)
1433{
1434 std::string s = "test";
1435 return 0;
1436}
1437EOF
1438 if test_compile "$libstdcxx" libstdc++ libstdc++; then
1439 log_success "found"
1440 fi
1441}
1442
1443
1444#
1445# Check for Linux sources
1446#
1447check_linux()
1448{
1449 test_header "Linux kernel sources"
1450 cat > $ODIR.tmp_src.c << EOF
1451#include <linux/version.h>
1452int printf(const char *format, ...);
1453int main(void)
1454{
1455 printf("found version %d.%d.%d", LINUX_VERSION_CODE / 65536,
1456 (LINUX_VERSION_CODE % 65536) / 256,
1457 LINUX_VERSION_CODE % 256);
1458#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
1459 printf(", OK.\n");
1460 return 0;
1461#else
1462 printf(", expected version 2.4.0 or higher\n");
1463 return 1;
1464#endif
1465}
1466EOF
1467 echo "compiling the following source file:" >> $LOG
1468 cat $ODIR.tmp_src.c >> $LOG
1469 echo "using the following command line:" >> $LOG
1470 echo "$CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include" >> $LOG
1471 $CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include >> $LOG 2>&1
1472 if [ $? -ne 0 ]; then
1473 echo
1474 echo " Linux kernel headers not found at $LINUX"
1475 echo " Check the file $LOG for detailed error information."
1476 fail
1477 else
1478 if test_execute; then
1479 cnf_append "VBOX_LINUX_SRC" "`cd $LINUX ; pwd`"
1480 fi
1481 fi
1482}
1483
1484
1485#
1486# Check for kchmviewer, needed to display the online help
1487# (unused as we ship kchmviewer)
1488#
1489check_kchmviewer()
1490{
1491 test_header kchmviewer
1492 if check_avail "$KCHMVIEWER" KCHMVIEWER; then
1493 kchmviewer_ver=`$KCHMVIEWER --version|grep "^KchmViewer:"|sed 's+^KchmViewer: \(.*\)+\1+'`
1494 if [ $? -ne 0 ]; then
1495 log_failure "not found"
1496 fail
1497 else
1498 log_success "found version $kchmviewer_ver"
1499 fi
1500 fi
1501}
1502
1503
1504#
1505# Check for the kBuild tools, we don't support GNU make
1506#
1507check_kbuild()
1508{
1509 test_header kBuild
1510 if which_wrapper "$KBUILDDIR/bin/$OS.$BUILD_MACHINE/kmk" > /dev/null; then
1511 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.$BUILD_MACHINE"
1512 echo "export PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1513 echo "export PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1514 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"" >> $ENV
1515 echo "export PATH_KBUILD_BIN=\"\$path_kbuild_bin\"" >> $ENV
1516 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1517 if [ "$OS" = "solaris" ]; then
1518 # Because of sh being non-default shell in Solaris we need to export PATH again when
1519 # sourcing env.sh. Simply exporting from ./configure does not export PATH correctly.
1520 echo "PATH=\"$ORGPATH\"" >> $ENV
1521 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1522 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1523 else
1524 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1525 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1526 fi
1527 echo "export PATH" >> $ENV
1528 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1529 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1530 elif check_avail "kmk" KBUILDDIR really; then
1531 # check for installed kBuild
1532 KBUILD_SED="`which_wrapper kmk_sed`"
1533 else
1534 fail
1535 fi
1536 log_success "found"
1537}
1538
1539
1540#
1541# Check for compiler.h
1542# Some Linux distributions include "compiler.h" in their libc linux
1543# headers package, some don't. Most don't need it, building might (!)
1544# not succeed on openSUSE without it.
1545#
1546# See http://www.mail-archive.com/qemu-devel%40nongnu.org/msg07980.html
1547#
1548check_compiler_h()
1549{
1550 test_header compiler.h
1551 if ! test -f "/usr/include/linux/compiler.h"; then
1552 log_success "compiler.h not found"
1553 else
1554 cnf_append "VBOX_WITH_LINUX_COMPILER_H" "1"
1555 log_success "compiler.h found"
1556 fi
1557}
1558
1559#
1560# Check for libcap.
1561# Required to pass CAP_NET_RAW to our binaries to allow to open SOCK_RAW
1562# sockets for doing ICMP requests.
1563#
1564check_libcap()
1565{
1566 test_header "libcap library"
1567 cat > $ODIR.tmp_src.cc << EOF
1568#include <cstdio>
1569#include <sys/types.h>
1570#include <sys/capability.h>
1571
1572extern "C" int main(void)
1573{
1574 char buf[1024];
1575 cap_t caps = cap_get_proc();
1576 snprintf(buf, sizeof(buf), "Current caps are '%s'\n", cap_to_text(caps, NULL));
1577 return 0;
1578}
1579EOF
1580 if test_compile $LIBCAP libcap libcap; then
1581 if test_execute; then
1582 log_success "found"
1583 fi
1584 fi
1585}
1586
1587#
1588# Check if we are able to build 32-bit applications (needed for the guest additions)
1589#
1590check_32bit()
1591{
1592 test_header "32-bit support"
1593 cat > $ODIR.tmp_src.c << EOF
1594#include <stdint.h>
1595int main(void)
1596{
1597 return 0;
1598}
1599EOF
1600 echo "compiling the following source file:" >> $LOG
1601 cat $ODIR.tmp_src.c >> $LOG
1602 echo "using the following command line:" >> $LOG
1603 echo "$CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
1604 $CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
1605 if [ $? -ne 0 ]; then
1606 echo
1607 echo " Cannot compile 32-bit applications (missing headers and/or libraries)!"
1608 echo " Check the file $LOG for detailed error information."
1609 fail
1610 fi
1611 log_success ""
1612}
1613
1614
1615#
1616# Check for Python
1617#
1618check_python()
1619{
1620 test_header "python support"
1621 cat > $ODIR.tmp_src.cc << EOF
1622#include <cstdio>
1623#include <Python.h>
1624extern "C" int main(void)
1625{
1626 Py_Initialize();
1627 printf("found version %s", PY_VERSION);
1628#if PY_VERSION_HEX >= 0x02030000
1629 printf(", OK.\n");
1630 return 0;
1631#else
1632 printf(", expected version 2.3 or higher\n");
1633 return 1;
1634#endif
1635}
1636EOF
1637 found=
1638# For Solaris we use libpython2.4 for compatibility with Solaris 10 and passing IPS pkg audit
1639 if [ "$OS" != "solaris" ]; then
1640 SUPPYTHONLIBS="python2.6 python2.5 python2.4 python2.3"
1641 else
1642 SUPPYTHONLIBS="python2.4"
1643 fi
1644 for p in $PYTHONDIR; do
1645 for d in $SUPPYTHONLIBS; do
1646 for b in lib64 lib/64 lib; do
1647 echo "compiling the following source file:" >> $LOG
1648 cat $ODIR.tmp_src.cc >> $LOG
1649 echo "using the following command line:" >> $LOG
1650 echo "$CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so" >> $LOG
1651 $CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so >> $LOG 2>&1
1652 if [ $? -eq 0 ]; then
1653 found=1
1654 break
1655 fi
1656 done
1657 if [ -n "$found" ]; then break; fi
1658 done
1659 if [ -n "$found" ]; then break; fi
1660 done
1661 if [ -n "$found" ]; then
1662 if test_execute; then
1663 cnf_append "VBOX_WITH_PYTHON" "1"
1664 cnf_append "VBOX_PATH_PYTHON_INC" "$p/include/$d"
1665 cnf_append "VBOX_LIB_PYTHON" "$p/$b/lib$d.so"
1666 else
1667 log_failure "not found"
1668 fail
1669 fi
1670 else
1671 log_failure "not found"
1672 fail
1673 fi
1674}
1675
1676
1677#
1678# Setup wine
1679#
1680setup_wine()
1681{
1682 test_header "Wine support"
1683 if ! which_wrapper wine > /dev/null; then
1684 echo " wine binary not found"
1685 fail
1686 fi
1687 if ! which_wrapper wineprefixcreate > /dev/null; then
1688 echo " wineprefixcreate not found"
1689 fail
1690 fi
1691 export WINEPREFIX="${ODIR}wine.$BUILD_MACHINE"
1692 echo "export WINEPREFIX=\"${ODIR}wine.$BUILD_MACHINE\"" >> $ENV
1693 rm -rf $WINEPREFIX
1694 mkdir -p $WINEPREFIX
1695 touch $WINEPREFIX/.no_prelaunch_window_flag
1696 if ! wineprefixcreate -q > /dev/null 2>&1; then
1697 echo " wineprefixcreate failed"
1698 fail
1699 fi
1700 tmp=.tmp.wine.reg
1701 rm -f $tmp
1702 echo 'REGEDIT4' > $tmp
1703 echo '' >> $tmp
1704 echo '[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Session Manager\Environment]' >> $tmp
1705 echo "\"PATH\"=\"c:\\\\\\\\windows\\\\\\\\system32;c:\\\\\\\\windows;z:$DEVDIR/win.x86/vcc/v8/bin/Microsoft.VC80.CRT;z:$DEVDIR/win.x86/HTML_Help_Workshop/v1.3\"" >> $tmp
1706 echo '' >> $tmp
1707 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhc.exe\DllOverrides]' >> $tmp
1708 echo '"itss"="native"' >> $tmp
1709 echo '' >> $tmp
1710 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhw.exe\DllOverrides]' >> $tmp
1711 echo '"itss"="native"' >> $tmp
1712 echo '' >> $tmp
1713 if ! wine regedit $tmp > /dev/null 2>&1; then
1714 rm -f $tmp
1715 echo " failed to load registry changes (path)."
1716 fail
1717 fi
1718 rm -f $tmp
1719 log_success "found"
1720}
1721
1722#
1723# Check for gSOAP.
1724#
1725check_gsoap()
1726{
1727 test_header "GSOAP compiler"
1728 if [ -z "$GSOAP" ]; then
1729 GSOAP="/usr"
1730 fi
1731 if which_wrapper "$GSOAP/bin/soapcpp2" > /dev/null; then
1732 if which_wrapper "$GSOAP/bin/wsdl2h" > /dev/null; then
1733 if [ -f "$GSOAP/include/stdsoap2.h" ]; then
1734 # TODO: Check for libgsoap++.a/so
1735
1736 if [ -z "$GSOAP_IMPORT" ]; then
1737 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
1738 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
1739 GSOAP_IMPORT="$GSOAP/include/gsoap"
1740 fi
1741 fi
1742 if [ -f "$GSOAP_IMPORT/stlvector.h" ]; then
1743 cnf_append "VBOX_GSOAP_INSTALLED" "1"
1744 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
1745 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
1746 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
1747 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
1748 else
1749 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
1750 fi
1751 cnf_append "VBOX_GSOAP_CXX_LIBS" "libgsoap++"
1752 log_success "found"
1753 else
1754 log_failure "stlvector.h not found -- disabling webservice"
1755 cnf_append "VBOX_WITH_WEBSERVICES" ""
1756 fi
1757 else
1758 log_failure "stdsoap2.h not found -- disabling webservice"
1759 cnf_append "VBOX_WITH_WEBSERVICES" ""
1760 fi
1761 else
1762 log_failure "wsdl2h not found -- disabling webservice"
1763 cnf_append "VBOX_WITH_WEBSERVICES" ""
1764 fi
1765 else
1766 log_failure "soapcpp2 not found -- disabling webservice"
1767 cnf_append "VBOX_WITH_WEBSERVICES" ""
1768 fi
1769}
1770
1771
1772#
1773# Determines the Darwin version.
1774# @todo This should really check the Xcode/SDK version.
1775#
1776check_darwinversion()
1777{
1778 test_header "Darwin version"
1779 darwin_ver=`uname -r`
1780 case "$darwin_ver" in
1781 9\.*)
1782 darwin_ver="10.5"
1783 #cnf_append "VBOX_TARGET_MAC_OS_X_VERSION_10_5" "1"
1784 ;;
1785 8\.*)
1786 darwin_ver="10.4"
1787 ;;
1788 *)
1789 echo " failed to determin darwin version. (uname -r: $darwin_ver)"
1790 fail
1791 darwin_ver="unknown"
1792 ;;
1793 esac
1794 log_success "found version $darwin_ver"
1795}
1796
1797
1798#
1799# Checks that i386-elf-gcc-3.4.6, i386-elf-gcc-3.4.3, i386-elf-gcc-3.4 or i386-elf-gcc
1800# is around to prevent confusion when the build fails in src/recompiler.
1801# Note. Keep the which order in sync with the $(which ) in src/recompiler/Makefile.kmk.
1802#
1803check_i386elfgcc()
1804{
1805 test_header "i386-elf-gcc"
1806 i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.6`
1807 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.3`
1808 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4`
1809 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc`
1810 if test -z "$i386_elf_gcc"; then
1811 echo " failed to find i386-elf-gcc"
1812 fail
1813 fi
1814 log_success "found $i386_elf_gcc"
1815}
1816
1817
1818#
1819# Show help
1820#
1821show_help()
1822{
1823 cat << EOF
1824Usage: ./configure [OPTIONS]...
1825
1826Configuration:
1827 -h, --help display this help and exit
1828 --nofatal don't abort on errors
1829 --disable-xpcom disable XPCOM and related stuff
1830 --disable-python disable python bindings
1831 --disable-sdl-ttf disable SDL_ttf detection
1832 --disable-alsa disable the ALSA sound backend
1833 --disable-pulse disable the PulseAudio backend
1834 --disable-dbus don't use DBus and hal for hardware detection
1835 --disable-kmods don't build Linux kernel modules (host and guest)
1836 --disable-hardening don't be strict about /dev/vboxdrv access
1837 --disable-opengl disable OpenGL support
1838 --enable-webservice enable the webservice stuff
1839 --build-libxml2 build libxml2 from sources
1840 --build-libxslt build libxslt from sources
1841 --setup-wine setup a Wine directory and register the hhc hack
1842
1843Paths:
1844 --with-gcc=PATH location of the gcc compiler [$CC]
1845 --with-g++=PATH location of the g++ compiler [$CXX]
1846 --with-kbuild=DIR kbuild directory [$KBUILDDIR]
1847 --with-iasl=PATH location of the iasl compiler [$IASL]
1848 --with-linux=DIR Linux kernel source directory [$LINUX]
1849 --with-mkisofs=PATH location of mkisofs [$MKISOFS]
1850 --with-qt-dir=DIR directory for Qt4 headers/libraries [pkgconfig]
1851 --with-gsoap-dir=PATH directory for gSOAP compiler/headers/libraries
1852 (soapcpp2 and wsdl2h, soapstd2.h, libgsoap++.a/so)
1853 --with-gsoap-import=PATH directory for gSOAP import files (stlvector.h)
1854 --out-path=PATH the folder to which configuration and build output
1855 should go
1856
1857Build type:
1858 -d, --build-debug build with debugging symbols and assertions
1859 --build-profile build with profiling support
1860 --build-headless build headless (without any X11 frontend)
1861EOF
1862 exit 0
1863}
1864
1865
1866#
1867# The body.
1868#
1869
1870# scan command line options
1871for option in $*; do
1872 case "$option" in
1873 --help|-help|-h)
1874 show_help
1875 ;;
1876 --nofatal)
1877 nofatal=1
1878 ;;
1879 --env-only)
1880 ENV_ONLY=1
1881 ;;
1882 --with-gcc=*)
1883 CC=`echo $option | cut -d'=' -f2`
1884 ;;
1885 --with-g++=*)
1886 CXX=`echo $option | cut -d'=' -f2`
1887 ;;
1888 --with-kbuild=*)
1889 KBUILDDIR=`echo $option | cut -d'=' -f2`
1890 if echo $KBUILDDIR|grep -q "$INVALID_CHARS"; then
1891 echo "Error: KBUILDDIR contains invalid characters!"
1892 exit 1
1893 fi
1894 ;;
1895 --with-qt-dir=*|--with-qt4-dir=*)
1896 QT4DIR=`echo $option | cut -d'=' -f2`
1897 QT4DIR_PKGCONFIG=0
1898 ;;
1899 --with-gsoap-dir=*)
1900 GSOAP=`echo $option | cut -d'=' -f2`
1901 ;;
1902 --with-gsoap-import=*)
1903 GSOAP_IMPORT=`echo $option | cut -d'=' -f2`
1904 ;;
1905 --with-iasl=*)
1906 IASL=`echo $option | cut -d'=' -f2`
1907 ;;
1908 --with-linux=*)
1909 LINUX=`echo $option | cut -d'=' -f2`
1910 ;;
1911 --with-mkisofs=*)
1912 MKISOFS=`echo $option | cut -d'=' -f2`
1913 ;;
1914 --disable-xpcom)
1915 WITH_XPCOM=0
1916 ;;
1917 --disable-python)
1918 WITH_PYTHON=0
1919 ;;
1920 --disable-sdl-ttf)
1921 WITH_SDL_TTF=0
1922 ;;
1923 --disable-qt)
1924 WITH_QT4=0
1925 ;;
1926 --disable-qt4)
1927 WITH_QT4=0
1928 ;;
1929 --disable-alsa)
1930 WITH_ALSA=0
1931 ;;
1932 --disable-pulse)
1933 WITH_PULSE=0
1934 ;;
1935 --disable-dbus)
1936 WITH_DBUS=0
1937 ;;
1938 --disable-kmods)
1939 WITH_KMODS=0
1940 ;;
1941 --disable-opengl)
1942 WITH_OPENGL=0
1943 ;;
1944 --disable-hardening)
1945 WITH_HARDENING=0
1946 ;;
1947 --enable-hardening)
1948 WITH_HARDENING=2
1949 ;;
1950 --enable-webservice)
1951 WITH_GSOAP=1
1952 ;;
1953 --build-debug|-d)
1954 BUILD_TYPE=debug
1955 ;;
1956 --build-profile)
1957 BUILD_TYPE=profile
1958 ;;
1959 --build-libxml2)
1960 BUILD_LIBXML2=1
1961 ;;
1962 --build-libxslt)
1963 BUILD_LIBXSLT=1
1964 ;;
1965 --build-headless)
1966 HEADLESS=1
1967 WITH_SDL=0
1968 WITH_SDL_TTF=0
1969 WITH_X11=0
1970 WITH_OPENGL=0
1971 WITH_QT4=0
1972 ;;
1973 --ose)
1974 OSE=2
1975 ;;
1976 --odir=*)
1977 ODIR="`echo $option | cut -d'=' -f2`/"
1978 ODIR_OVERRIDE=1
1979 ;;
1980 --out-path=*)
1981 out_path="`echo $option | cut -d'=' -f2`/"
1982 if [ -d $out_path ]; then
1983 saved_path="`pwd`"
1984 cd $out_path
1985 OUT_PATH="`pwd`"
1986 cd $saved_path
1987 OUT_PATH_OVERRIDE=1
1988 if [ $ODIR_OVERRIDE -eq 0 ]; then
1989 # This variable has not *yet* been overridden. That can still happen.
1990 ODIR=$OUT_PATH/
1991 fi
1992 else
1993 echo "Error: invalid folder \"$out_path\" in option \"$option\""
1994 exit 1
1995 fi
1996 ;;
1997 --setup-wine)
1998 SETUP_WINE=1
1999 ;;
2000 *)
2001 echo
2002 echo "Unrecognized option \"$option\""
2003 echo
2004 show_help
2005 ;;
2006 esac
2007done
2008
2009LOG="$ODIR$LOG"
2010ENV="$ODIR$ENV"
2011CNF="$ODIR$CNF"
2012
2013# initialize output files
2014cat > $LOG << EOF
2015# Log file generated by
2016#
2017# '$0 $*'
2018#
2019
2020EOF
2021cat > $CNF << EOF
2022# -*- Makefile -*-
2023#
2024# automatically generated by
2025#
2026# '$0 $*'
2027#
2028# It will be completely overwritten if configure is executed again.
2029#
2030
2031EOF
2032cat > $ENV << EOF
2033#!/bin/bash
2034#
2035# automatically generated by
2036#
2037# '$0 $*'
2038#
2039# It will be completely overwritten if configure is executed again.
2040# Make sure you source this file once before you start to build VBox.
2041#
2042
2043EOF
2044
2045# test if we are OSE
2046if [ $OSE -eq 1 -a -d "`cd \`dirname $0\`; pwd`/src/VBox/Devices/USB" ]; then
2047 echo "Found USB devices, assuming VBOX_OSE = FALSE" >> $LOG
2048 echo >> $LOG
2049 OSE=0
2050fi
2051
2052if [ "$BUILD_TYPE" = "debug" ]; then
2053 echo "Creating DEBUG build!" >> $LOG
2054elif [ "$BUILD_TYPE" = "profile" ]; then
2055 echo "Creating PROFILE build!" >> $LOG
2056fi
2057
2058# first determine our environment
2059check_environment
2060check_kbuild
2061
2062[ -n "$ENV_ONLY" ] && exit 0
2063
2064# append the tools directory to the default search path
2065echo "$PATH" | grep -q "$DEVDIR_BIN" || PATH="$PATH:$DEVDIR_BIN"
2066export PATH
2067
2068# if we will be writing to a different out directory then set this up now
2069if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2070 echo "export AUTOCFG=$OUT_PATH/AutoConfig.kmk" >> $ENV
2071 echo "export LOCALCFG=$OUT_PATH/LocalConfig.kmk" >> $ENV
2072 echo "export PATH_OUT_BASE=$OUT_PATH" >> $ENV
2073fi
2074
2075# some things are not available in for OSE
2076if [ $OSE -ge 1 ]; then
2077 cnf_append "VBOX_OSE" "1"
2078 cnf_append "VBOX_WITH_TESTSUITE" ""
2079 cnf_append "VBOX_WITH_WIN32_ADDITIONS" ""
2080
2081 if [ "$OS" = "linux" ]; then
2082 cnf_append "VBOX_WITH_LINUX_ADDITIONS" "1"
2083 else
2084 cnf_append "VBOX_WITH_LINUX_ADDITIONS" ""
2085 fi
2086 echo >> $CNF
2087fi
2088
2089# headless
2090if [ -n "$HEADLESS" ]; then
2091 cnf_append "VBOX_HEADLESS" "1"
2092fi
2093
2094if [ $WITH_OPENGL -eq 0 ]; then
2095 cnf_append "VBOX_WITH_CROGL" ""
2096fi
2097
2098if [ "$OS" = "darwin" ]; then
2099 # On Darwin we want to build against Qt4 only. WITH_QT4 is enabled by
2100 # default so disable Qt3. --disable-qt disables both Qt3 and Qt4 GUI now,
2101 # --disable-qt4 disables only the Qt4 GUI (which is not appropriate for
2102 # Darwin as we disable the Qt3 here anyway.
2103 # (Qt3 builds for Intel Macs are usually not threaded or for X11. And they
2104 # don't contain our patches, which means the result isn't really usable.)
2105 BUILD_LIBXSLT=1
2106 BUILD_LIBXML2=1
2107fi
2108
2109# emit disable directives corresponding to any --disable-xxx options.
2110[ $WITH_XPCOM -eq 0 ] && cnf_append "VBOX_WITH_MAIN" ""
2111[ $WITH_QT4 -eq 0 ] && cnf_append "VBOX_WITH_QTGUI" ""
2112[ $WITH_SDL_TTF -eq 0 ] && cnf_append "VBOX_WITH_SECURELABEL" ""
2113[ $WITH_HARDENING -eq 0 ] && cnf_append "VBOX_WITHOUT_HARDENING" "1"
2114[ $WITH_HARDENING -eq 2 ] && cnf_append "VBOX_WITH_HARDENING" "2"
2115
2116# the tools
2117check_gcc
2118[ "$OS" != "darwin" ] && check_as86
2119[ "$OS" != "darwin" ] && check_bcc
2120[ "$OS" != "darwin" ] && check_iasl
2121# don't check for yasm for the time beeing as 0.40 and 0.50 both have known bugs
2122# [ "$OS" != "darwin" ] && check_yasm
2123[ "$OS" != "darwin" ] && check_xsltproc
2124[ $OSE -eq 0 -a "$OS" != "darwin" ] && check_mkisofs
2125
2126# the libraries
2127[ "$OS" != "darwin" ] && check_pthread
2128[ $WITH_XPCOM -eq 1 ] && check_libxml2
2129[ $WITH_XPCOM -eq 1 ] && check_libxslt
2130[ $WITH_LIBIDL -eq 1 ] && check_libidl
2131# build openssl on Darwin in every case
2132[ "$OS" != "darwin" -a $OSE -eq 0 ] && check_ssl
2133[ "$OS" != "darwin" ] && check_z
2134[ "$OS" != "darwin" -a "$OS" != "freebsd" ] && check_png
2135[ $OSE -eq 0 -a "$OS" = "linux" ] && check_pam
2136[ $WITH_SDL -eq 1 ] && check_sdl
2137[ $WITH_SDL_TTF -eq 1 -a $OSE -eq 0 ] && check_sdl_ttf
2138[ $WITH_X11 -eq 1 ] && check_x
2139# TODO check for xcomposite-dev (X11/extensions/Xcomposite.h, additions only)
2140# TODO check for libxdamange-dev (X11/extensions/Xdamage.h, additions only)
2141[ $WITH_X11 -eq 1 ] && check_xcursor
2142[ $WITH_OPENGL -eq 1 ] && check_xmu
2143[ $WITH_OPENGL -eq 1 ] && check_mesa
2144[ $WITH_QT4 -eq 1 ] && check_qt4
2145[ $WITH_PYTHON -eq 1 -a "$OS" != "darwin" ] && check_python
2146
2147# Linux-specific
2148if [ "$OS" = "linux" ]; then
2149 # don't check for the static libstdc++ in the PUEL version as we build the
2150 # additions at a dedicated box
2151 [ $OSE -ge 1 ] && check_staticlibstdcxx
2152 if [ $WITH_KMODS -eq 1 ]; then
2153 check_linux
2154 else
2155 cnf_append "VBOX_LINUX_SRC" ""
2156 cnf_append "VBOX_WITH_VBOXDRV" ""
2157 cnf_append "VBOX_WITH_ADDITION_DRIVERS" ""
2158 fi
2159 if [ $WITH_ALSA -eq 1 ]; then
2160 check_alsa
2161 else
2162 cnf_append "VBOX_WITH_ALSA" ""
2163 fi
2164 if [ $WITH_PULSE -eq 1 ]; then
2165 check_pulse
2166 else
2167 cnf_append "VBOX_WITH_PULSE" ""
2168 fi
2169 if [ $WITH_DBUS -eq 0 ]; then
2170 cnf_append "VBOX_WITH_DBUS" ""
2171 fi
2172 check_libcap
2173 check_compiler_h
2174 [ "$BUILD_MACHINE" = "amd64" ] && check_32bit
2175fi
2176
2177[ -n "$SETUP_WINE" ] && setup_wine
2178
2179if [ $OSE -ge 1 ]; then
2180 if [ $WITH_GSOAP -eq 1 ]; then
2181 check_gsoap
2182 else
2183 cnf_append "VBOX_WITH_WEBSERVICES" ""
2184 fi
2185fi
2186
2187# Darwin-specific
2188if [ "$OS" = "darwin" ]; then
2189 check_darwinversion
2190 check_i386elfgcc
2191fi
2192
2193# success!
2194echo
2195echo "Successfully generated '$CNF' and '$ENV'."
2196echo "Source '$ENV' once before you start to build VBox:"
2197echo ""
2198echo " source $ENV"
2199echo " kmk"
2200echo ""
2201if [ "$OS" = "linux" ]; then
2202 if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2203 vbox_out_path=$OUT_PATH
2204 else
2205 vbox_out_path=./out
2206 fi
2207 echo "To compile the kernel modules, do:"
2208 echo ""
2209 echo " cd $vbox_out_path/$OS.$TARGET_MACHINE/$BUILD_TYPE/bin/src"
2210 echo " make"
2211 echo ""
2212fi
2213if [ $WITH_HARDENING -gt 0 ]; then
2214 echo ""
2215 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2216 echo " Hardening is enabled which means that the VBox binaries will not run from"
2217 echo " the binary directory. The binaries have to be installed suid root and some"
2218 echo " more prerequisites have to be fulfilled which is normally done by installing"
2219 echo " the final package. For development, the hardening feature can be disabled"
2220 echo " by specifying the --disable-hardening parameter. Please never disable that"
2221 echo " feature for the final distribution!"
2222 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2223 echo ""
2224else
2225 echo ""
2226 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2227 echo " Hardening is disabled. Please do NOT build packages for distribution with"
2228 echo " disabled hardening!"
2229 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2230 echo ""
2231fi
2232echo "Enjoy!"
2233cleanup
Note: See TracBrowser for help on using the repository browser.

© 2024 Oracle Support Privacy / Do Not Sell My Info Terms of Use Trademark Policy Automated Access Etiquette